package org.pervml.drivers.presenceDetector;

import java.io.IOException;
import java.util.Hashtable;
import java.util.Properties;
import java.util.HashMap;


import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;
import org.osgi.framework.Constants;
import org.osgi.framework.InvalidSyntaxException;
import org.osgi.framework.ServiceEvent;
import org.osgi.framework.ServiceListener;
import org.osgi.framework.ServiceReference;
import org.osgi.framework.ServiceRegistration;

import org.osgi.service.event.Event;
import org.osgi.service.event.EventConstants;
import org.osgi.service.event.EventHandler;
import org.osgi.service.wireadmin.Consumer;
import org.osgi.service.wireadmin.Producer;
import org.osgi.service.wireadmin.Wire;
import org.osgi.service.wireadmin.WireAdmin;

import com.prosyst.mbs.services.knx.KnxUtil;
import com.prosyst.mbs.services.knx.cemi.Priority;
import com.prosyst.mbs.services.knx.cemi.frames.L_Data_cEMI;
import com.prosyst.mbs.services.knx.dpt.DPT2ByteFloatValue;
import com.prosyst.mbs.services.knx.dpt.DPTException;
import com.prosyst.mbs.services.knx.layerApp.MulticastService;
import com.prosyst.mbs.services.knx.layerData.DataLink;


public class Activator implements BundleActivator {

  //private static final String FILTER = //
  //"(OBJECTCLASS=" + DataLink.CLASS + ')';

  private ServiceReference dataLinkRef;
  //private Controller controller;
  private ServiceRegistration eventHandlerReg;
  private BundleContext bc;
  private DataLink dataLink;
  private PresenceDetector PDetectorEIB;
  private WireAdmin wa;
  //private Hashtable props = new Hashtable(2);
  //private boolean enable=true;
  //public int statePresence=0;
  private boolean presence = false;

  /**
   * @see org.osgi.framework.BundleActivator#start(org.osgi.framework.BundleContext)
   */
  public void start(BundleContext bc) throws Exception {
	  
	  String topics[] = { DataLink.TOPIC_CONNECT, // When the data link driver connects
              DataLink.TOPIC_DISCONNECT, // Disconnected
              DataLink.TOPIC_FRAME, // Incoming frame event
	  };
	  
	  Hashtable props2 = new Hashtable(2);
	  props2.put(EventConstants.EVENT_TOPIC, topics);
	  
	  
	  EventHandler handler = new EventHandler() {

	      public void handleEvent(Event event) {
	    	  // Escribe los eventos recibidos
	    	  L_Data_cEMI frame = (L_Data_cEMI) event.getProperty(DataLink.P_FRAME);
	    	  //System.out.println("Estoy aqui");
	    	  //printFrame(frame);
	    	  String group;
	    	  group = KnxUtil.toString(frame.getDestination(), KnxUtil.ADDRESS3, '/');
	    	  if(group.equals("1/4/10") && frame.getDataShort() == 1){
	    		  System.out.println("*******Detectada presencia********");
		    	  PDetectorEIB.presence=true;
	    		  presence=true;
	    		  PDetectorEIB.notifyConsumers();
	    	  }
	    	  
	    	  if(group.equals("1/4/10") && frame.getDataShort() == 0){
	    		  System.out.println("*******Ya no detecto presencia!!!********");	    		  
	    		  presence=false;
	    		  PDetectorEIB.presence=false;
	    		  PDetectorEIB.notifyConsumers();
	    	  }
	      }		
	  };

	  eventHandlerReg = bc.registerService(EventHandler.class.getName(), handler,props2);  
	  this.bc = bc;
	  String driverPID = "PD1";
	  Properties props = new Properties();
	  props.put(org.osgi.framework.Constants.SERVICE_PID,driverPID);
	  props.put(org.osgi.service.wireadmin.WireConstants.WIREADMIN_PRODUCER_FLAVORS,
   			new Class[] { HashMap.class });
	  props.put(org.osgi.service.wireadmin.WireConstants.WIREADMIN_CONSUMER_FLAVORS,
	   			new Class[] { HashMap.class });
	  
	  try {
		  PDetectorEIB = new PresenceDetector(bc,presence);
		  System.out.println("entra driverEIB.java, se registra: " + driverPID);
		  String interfaz = PDetectorEIB.getClass().getInterfaces()[0].getName();
		  
		  bc.registerService(Consumer.class.getName(),PDetectorEIB,props);
		  bc.registerService(Producer.class.getName(),PDetectorEIB,props);
	      bc.registerService(interfaz,PDetectorEIB,props);
	      
	      ServiceReference sr = bc.getServiceReference(WireAdmin.class.getName());
	      
	      if(sr != null){
	    	  wa = (WireAdmin) bc.getService(sr);
	      }
	      String producerPID = "Listener";
	      String wid = producerPID + driverPID;
	      Hashtable props3 = new Hashtable();
	      props3.put("PervML_WireID", wid);
	      //wa.createWire(producerPID, driverPID, props3);
	      
	      if(presence){
	    	  PDetectorEIB.notifyConsumers();
	    	  PDetectorEIB.presence=true;
	      }
	      else
	      {
	    	  PDetectorEIB.presence=false;
	    	  PDetectorEIB.notifyConsumers();
	    	  
	      }
	  } catch (Exception e){
		  System.out.println("\n\n\nexceptionBP del framework: " + e.getMessage());
	  }
		  
}	
  

  public void stop(BundleContext bc) throws Exception {
	
	  Wire aux;
	  try{  
		  Wire [] wires=wa.getWires(null);
		  for(int i=0;i<wires.length;i++){
			  aux= (Wire) wires[i];
			  wa.deleteWire(aux);
			  i++;
		  }
	  }
	  catch(Exception E){System.out.println("excepcion al eliminar los wires");}
  }

}