package org.pervml.drivers.presenceDetector;

import java.io.IOException;
import java.util.HashMap;

import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceReference;
import org.osgi.service.event.Event;
import org.osgi.service.event.EventHandler;
import org.osgi.service.wireadmin.Consumer;
import org.osgi.service.wireadmin.Producer;
import org.osgi.service.wireadmin.Wire;

import com.prosyst.mbs.services.knx.KnxUtil;
import com.prosyst.mbs.services.knx.cemi.frames.L_Data_cEMI;
import com.prosyst.mbs.services.knx.layerData.DataLink; 

public class PresenceDetector implements org.pervml.bproviders.interfaces.PresenceDetector.Interface, Consumer, Producer {
	  private BundleContext context;
	  DataLink dataLink;
	  public boolean presence = false;
	  private boolean enable=true;
	
	protected void notifyConsumers() {
		if ( this.wiresConsumer == null ) return; 
		
		System.out.println("+*+*+*+*+*WireParticipant: notifico a los consumers." + Integer.toString(wiresConsumer.length)+ "-"+ this.getClass().getName());
		for (int i=0; i<this.wiresConsumer.length; i++){
			System.out.println(".-.-.-.-. "+wiresConsumer[i].getProperties().get(org.osgi.framework.Constants.SERVICE_PID));
			System.out.println(wiresConsumer[i].getProperties().get("PervML_Location"));
			if(!(wiresConsumer[i].getProperties().get("wireadmin.consumer.pid").equals("")))
			{
				this.wiresConsumer[i].update(new HashMap());
				wiresConsumer[i].getProperties().get("wireadmin.producer.pid");
			
				System.out.println("productor del wire  " + wiresConsumer[i].getProperties().get("wireadmin.producer.pid"));
				System.out.println("consumidor del wire " +  wiresConsumer[i].getProperties().get("wireadmin.consumer.pid"));
			}
		}
	}
	protected Wire [] wiresConsumer = null;
	
	public void consumersConnected(Wire [] ws) {
		System.out.print("funciona consumers conected"+ ws.length);
		this.wiresConsumer = ws;
		System.out.println("EIB driver cantidad consumers: "+wiresConsumer.length);
	}
	public Object polled(Wire w) {		
		return null;
	}
  
		  
		  public PresenceDetector (BundleContext bc, boolean presence) {	
				this.context = bc;
				this.presence = presence;
				dataLink= ObtenerDataLink(bc);
				connect();
		  }
		  
		  private DataLink ObtenerDataLink(BundleContext bcont)
		  {
			  
			  
			  String FILTER = "(OBJECTCLASS=" + DataLink.CLASS + ')';
			  ServiceReference dataLinkRef=null;  // Referencia la servicio;

			  DataLink p;
			  ServiceReference ref = null;
			  try
			  {
				  ServiceReference refs[] = bcont.getServiceReferences(null, FILTER);
				  for (int i = 0; dataLinkRef == null && refs != null && i < refs.length; i++ ) {
					  ref = refs[i];
					  break;
				  }
			  
				  // 		a partir del contexto recuperamos la referencia y el datalink
				  if (dataLinkRef == null) {
					  dataLinkRef = ref;
					  p = (DataLink) bcont.getService(ref);
					  if (p== null)
					  {
						System.out.println("p==null");
						  return null;
					  }
					  
					  else 
					  {
							System.out.println("return p");
						  return p;
					  }
			    	 
			   	}
			  }catch (Exception e)
			  {
					System.out.println("exception");
				   return null;
			  }
			  
			return null;
				  
		  }
		  
		  public void connect() {
				if (dataLink.isConnected())
					System.out.println("conectado");
				  else {
					  System.out.println("desconectado-me conecto");
					  try {
						dataLink.connect();
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					} catch (InterruptedException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}	
				  }
			}
		  
		  protected Wire [] wiresProducer = null;
		  
			public void producersConnected(Wire[] wp){
					System.out.print("funciona consumers conected"+ wp.length);
					this.wiresProducer = wp;
					System.out.println("EIB driver cantidad productores: "+wiresProducer.length);
				}
			
			public void updated(Wire arg0, Object arg1) {
				
			}

			
			public boolean isPresenceDetected() {
				// TODO Auto-generated method stub
				return presence;
			}
			


}






