package org.pervml.framework;

import java.util.Properties;

import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;
import org.osgi.service.log.LogReaderService;
import org.osgi.util.tracker.ServiceTracker;
import org.pervml.framework.WireHelper.Controler;
import org.pervml.framework.WireHelper.LoggerListener;

public class Activator implements BundleActivator {
	protected BundleContext context = null;
	/*
	 * (non-Javadoc)
	 * @see org.osgi.framework.BundleActivator#start(org.osgi.framework.BundleContext)
	 */
	public void start(BundleContext context) throws Exception {
		this.context = context;
	
		
		System.out.println("-- PervML Framework --");
		System.out.print("Registering Logger...     ");
		registerLoggerListener();
		System.out.println("OK");
		System.out.print("Registering controller... ");
		registerController();
		System.out.println("OK");
	}

	private void registerController(){
		Properties controllerProps= new Properties();
        controllerProps.put(org.osgi.framework.Constants.SERVICE_PID,"controller");
        Controler controler = new Controler(context);
        context.registerService(Controler.class.getName(),controler ,controllerProps);
       
	}
	
	//subcribimos el loggerListener al log Service reader
	private void registerLoggerListener(){
		//LogReaderService debe estar en ejecucion, tal vez contemplar si no lo esta y esperarlo
		
		//creamos instancia
		LoggerListener loggerListener=new LoggerListener();
		//lo aadimos como listener
		 ServiceTracker logTracker = null;
		 LogReaderService loggerReader = null;
		logTracker = new ServiceTracker(this.context,LogReaderService.class.getName(),null);
	 	logTracker.open();
		
	 	loggerReader = (LogReaderService) logTracker.getService();
	 	loggerReader.addLogListener(loggerListener);
	 	//lo registramos como servicio
	 	Properties loggerListenerProps= new Properties();
	 	loggerListenerProps.put(org.osgi.framework.Constants.SERVICE_PID,"loggerListener");
        
        context.registerService(LoggerListener.class.getName(), loggerListener,loggerListenerProps);
	}
	
	/*
	 * (non-Javadoc)
	 * @see org.osgi.framework.BundleActivator#stop(org.osgi.framework.BundleContext)
	 */
	public void stop(BundleContext context) throws Exception {
	}

}
