/*
 * Created on 02-abr-2005 by capian
 *
 */
package org.pervml.framework.ActivatorHelper;



import java.util.HashMap;
import java.util.Hashtable;
import java.util.Properties;

import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;


import org.osgi.framework.InvalidSyntaxException;
import org.osgi.framework.ServiceEvent;
import org.osgi.framework.ServiceReference;
import org.osgi.service.wireadmin.Wire;
import org.osgi.service.wireadmin.WireAdmin;
import org.osgi.framework.ServiceListener;
import java.util.*;
import org.osgi.service.wireadmin.Producer;
import org.osgi.service.wireadmin.Consumer;
import org.pervml.framework.ActivatorHelper.list.ListaConPIEnlazada;

/**
 * @author capian
 *
 */
public abstract class FrameworkActivator implements BundleActivator, ServiceListener {
	
	protected BundleContext context = null;
	protected ListaConPIEnlazada servicesList = new ListaConPIEnlazada();
	
	protected ListaConPIEnlazada wiresList = new ListaConPIEnlazada();
	//
	private String serviceClassName;
	private String serviceSequenceId;
	private String servicePID;
	private String location;
	protected WireAdmin wa;
	
	
	
	public void start(BundleContext context) throws Exception {
		System.out.println("*******empieza Start de FrameworkActivator");
				ServiceReference sr = context.getServiceReference(WireAdmin.class.getName());
        if (sr!= null) {
        	 wa = (WireAdmin) context.getService(sr);
        	 //System.out.println("Antes del createAllWires");
        	//this.createAllWires(wa);
        } else {
        	context.addServiceListener(this,"(objectclass="+WireAdmin.class.getName()+")");
        }
		this.context = context;
		specificStart();
		//System.out.println("*******sigue genericStart");
		registerServices();
		System.out.println("*******despues de registrar servicios");
//		 Wire creation
        
      //  System.out.println("*******temina wire2");
        if (sr!= null) createAllWires(wa);
		
	}
	public  void stop(BundleContext context) {
		System.out.println("Voy a eliminar los wires que he creado"); 
		  try{
		  //	System.out.println("dentro para elimianr wires");
		wiresList.inicio();
		Wire aux;
		while (!wiresList.esFin()){
			//System.out.println("elimino uno");
           
           aux= (Wire) (wiresList.recuperar());
           wa.deleteWire(aux);
           wiresList.siguiente();
		}
		
		  }
	        catch(Exception e){System.out.println("excepcion eliminadno wires"+e.getMessage());}
		
	}
	
	public abstract void specificStart(); //Aadiremos a la lista de servicios todos los servicios de nuestro bundle
	
	protected  void registerServices(){
		 System.out.println("******************************register service******************");
		  GenericService aux;
		  servicesList.inicio();
		  
		  
		  
		  try{
		 /* 	aux= (GenericService) (servicesList.recuperar());
		  	Properties props = aux.getProperties();
			 props.put( org.osgi.service.wireadmin.WireConstants.WIREADMIN_PRODUCER_FLAVORS,
	        			new Class[] { HashMap.class });
	          props.put(org.osgi.service.wireadmin.WireConstants.WIREADMIN_CONSUMER_FLAVORS,
	            		new Class[] { HashMap.class });
	          context.registerService(Producer.class.getName(),aux.getInstance(),props);
	          context.registerService(Consumer.class.getName(),aux.getInstance(),props);
	        */ 
	            
	        while (!servicesList.esFin()){
	        	 
	            
	            aux= (GenericService) (servicesList.recuperar());
	            Properties props = aux.getProperties();
	            servicesList.siguiente();
	            System.out.println("Registro: " + aux.getName());
	            aux.getProperties().put( org.osgi.service.wireadmin.WireConstants.WIREADMIN_PRODUCER_FLAVORS,
	        			new Class[] {HashMap.class } );
	            aux.getProperties().put(org.osgi.service.wireadmin.WireConstants.WIREADMIN_CONSUMER_FLAVORS,
	            		new Class[]{HashMap.class} );
	           
	            context.registerService(aux.getName(),aux.getInstance(),props);
	        }
	       }
	        catch(Exception e){System.out.println(e.getMessage());}
	        

	}
	protected void createWire(WireAdmin wa, String producerPID, String consumerPID){
		String wid = producerPID+consumerPID;
		Wire [] ws = null;
		try {
			ws = wa.getWires("(PervML_WireID="+wid+")");
		} catch (Exception e) {
			System.out.println("Excepcion en createWire");
			e.printStackTrace();
			
		}

		if (ws == null){
			Hashtable props = new Hashtable();
			props.put("PervML_WireID",wid);
			props.put("PervML_Location","BProviders");
			if(props==null)
				System.out.println("PROPS ES NULL");
			else 	System.out.println("PROPS NO ES NULL");
			
			
			System.out.println("Antes de crearse el wire" + "prod: " +producerPID + "cons: " + consumerPID);
			
			wiresList.insertar(wa.createWire(producerPID, consumerPID, props));
			
			System.out.println("Se ha creado el wire" + "prod: " +producerPID + "cons: " + consumerPID);
		}
		else System.out.println("\n\nEl wire ya esta creado");
	}
	
	protected abstract void createAllWires(WireAdmin wa);
	
	public void serviceChanged(ServiceEvent event){
		/*if (event.getType() == ServiceEvent.REGISTERED) {
			WireAdmin wa = (WireAdmin)this.context.getService(event.getServiceReference());//mal!!!! una vez q este wireadmin sea quien sea el q se registre obliga a create all 
			this.createAllWires(wa);			
		}*/
	}
}
	

