/*
 * Created on 03-abr-2005 by capian
 *
 */
package org.pervml.framework.ActivatorHelper.list;
//Implementacin de la lista con PIEnlazada
public class ListaConPIEnlazada implements ListaConPI {
    // Atributos 
    //referencia al primer nodo de la lista, que es FICTICIO
    private NodoLista pri; 
    //referencia al anterior al PI
    private NodoLista ant; 
    //referencia al ltimo elemento de la lista
    private NodoLista fin; 
    
    // Una lista con PI vaca es un nodo FICTICIO
    public ListaConPIEnlazada() {
        
        pri = fin = ant = new NodoLista(null);
    }

    // Metodos para insertar, borrar y recuperar de la lista
    
    // inserta x ANTES del PI, por lo que el PI continua apuntando al mismo elemento
    public void insertar(Object x){
     
        NodoLista nuevo = new NodoLista(x);
        nuevo.sig = ant.sig;
        ant.sig = nuevo;
        if ( ant == fin) fin = ant.sig;
        ant = ant.sig;
    }
    // borra el elemento que ocupa el PI, por lo que el PI apunta al 
    // SIGUIENTE elemento  
    public void borrar() throws DesbordamientoInferior{
        
        if (ant == fin) throw new DesbordamientoInferior("Borrar");
        // Borrar el ltimo
        if (ant.sig == fin) fin = ant;
        ant.sig = ant.sig.sig;
    }

    public Object recuperar() throws PosicionIncorrecta {
        if (ant == fin) throw new PosicionIncorrecta("Recuperar");
        return ant.sig.dato;
    }
 
    public boolean esVacia(){
        return (pri == fin);
    }
    
    // Mtodos para manejar el punto de interes
    
    // el PI se situa al principio (prim) de la lista
    public void inicio(){
        
        ant = pri;
    }
    
    // el PI se situa al final (detrs de ult o fuera) de la lista
    public void fin(){
        
        ant = fin;
    }
    
    // avanza el PI
    public void siguiente() throws PosicionIncorrecta{
        
        if (ant == fin) throw new PosicionIncorrecta("Siguiente");
        ant = ant.sig;
    }
    
    public boolean esFin(){
    
        return (ant == fin);
    }
    
    public String toString () {
    
        NodoLista aux = pri.sig;
        String s = new String();
        while (aux != null) {
            s+=" "+aux.dato.toString();
            aux=aux.sig;
        }
        return s;
    }
    
} 
