/*
 * Created on 13-abr-2005 by Carlos
 *
 */
package org.pervml.framework.WireHelper;

import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Map;

import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceReference;

/**
 * @author OOMETHOD
 *
 */
public class Controler {
	
	private FrameworkSearcher componentSearcher;
	public Controler(BundleContext c){ 
		componentSearcher=new FrameworkSearcher(c);	
	}
	
	public String []searchServicesByAlias(String serviceName)
	{
	/*	String []PIDs= new String[0];
		ServiceReference [] refs= componentSearcher.getServiceReferenceFiltered("(PERVML_SERVICENAME="+serviceName+")");
 
		if (refs!=null){
 		
 		PIDs= new String[refs.length];
 		for (int i=0;i<refs.length;i++){
 			PIDs[i]=refs[i].getProperty(org.osgi.framework.Constants.SERVICE_PID).toString();
 		}
 			
 			
 	}	
 	 return PIDs;*/
    	return getFilteredServices("(PERVML_SERVICENAME="+serviceName+")");
    	
	}
	
	public String []getSubLocations(String actualLocation){
		String []services=this.getServices();
		System.out.println("****Buscamos sublocations de : "+actualLocation);
		HashSet hashSet= new HashSet(); 
		for (int i=0; i<services.length;i++)
		{
			hashSet.add(this.getSubLocation(services[i],actualLocation));
		}
		//en el caso de que algun servico no sea sublocation se inserta ""
		//eliminamos ""
		hashSet.remove("");
	Object [] objectsArray=hashSet.toArray();
	String [] locations = new String[objectsArray.length];
	for (int i = 0;i<objectsArray.length;i++){
		locations[i]=objectsArray[i].toString();
	}
	return locations;
	}
	public String []getKindsOfservice(){
		String []services=this.getServices();
		HashSet hashSet= new HashSet(); 
		for (int i=0; i<services.length;i++)
		{
			hashSet.add(getKindOfService(services[i]));
		}
			Object [] objectsArray=hashSet.toArray();
	String [] kindsOfservice = new String[objectsArray.length];
	for (int i = 0;i<objectsArray.length;i++){
		kindsOfservice[i]=objectsArray[i].toString();
	}
	return kindsOfservice;
	}
	public String [] getServicesFromLocation(String location){
		String filterString;
		filterString="(PERVML_LOCATION="+ location + ")";
		return this.getFilteredServices(filterString);
		
	}
	public String []getAlias(){
		String []services=this.getServices();
		HashSet hashSet= new HashSet(); 
		for (int i=0; i<services.length;i++)
		{
			hashSet.add(getAliasOfService(services[i]));
		}
			Object [] objectsArray=hashSet.toArray();
	String [] alias = new String[objectsArray.length];
	for (int i = 0;i<objectsArray.length;i++){
		alias[i]=objectsArray[i].toString();
	}
	return alias;
	}

	public String [] getServicesByKindOfService(String kindOfService){
		String filterString;
		filterString="(PERVML_KINDOFSERVICE="+ kindOfService + ")";
		return this.getFilteredServices(filterString);
		
	}
	public String [] getServicesByAlias(String alias){
		String filterString;
		filterString="(PERVML_SERVICENAME="+ alias + ")";
		return this.getFilteredServices(filterString);
		
	}
	private String getKindOfService(String PID){
		Map propierties=this.getProperties(PID);
		String kindOfService = propierties.get("kindOfService").toString();
		
				
			
		return kindOfService;
	}
	public String getAliasOfService(String PID){
		System.out.print("///get alias///");
		Map propierties=this.getProperties(PID);
		String alias = propierties.get("serviceName").toString();
		return alias;
	}
	private String getSubLocation(String PID, String actualLocation){
		Map propierties=this.getProperties(PID);
		Object [] vec= propierties.keySet().toArray();
		for (int i=0; i<propierties.keySet().size();i++){
			System.out.print("propiedad: "+ vec[i].toString());
			System.out.println(" - valor: "+ propierties.get(vec[i]));
		}
		
		String fullLocation = propierties.get("location").toString();
		//aadiremos "/" si no lo tiene ya al final
		if (!actualLocation.endsWith("/"))
			{
			actualLocation=actualLocation + "/";
			}
				
		//comprobaremos si es una sububicaci�n
		String subLocation="";
		
		if (fullLocation.startsWith(actualLocation))
			{
				subLocation=fullLocation.substring(actualLocation.length());
				//eliminarios el resto desde "/"
				int pos=subLocation.indexOf('/');
				if (pos<0)
					pos=subLocation.length();
				subLocation=subLocation.substring(0,pos);
				
			}
		return subLocation;
	}
	
	private String [] getFilteredServices(String filterString){
		ServiceReference [] refs=this.componentSearcher.getServiceReferenceFiltered(filterString);
		
		//eliminamos duplicados

		HashSet serviceNamesList=new HashSet();   	
		
		Object vectorServiceNames[]=new Object [refs.length];
		
		int numberRefs=0;
		ServiceReference refsNoDuplicate[]= new ServiceReference[refs.length];
		int j;
		boolean encontradoOtroIgual=false;
	    for (int i=0;i<refs.length;i++){
	    	j=0;
	    	encontradoOtroIgual=false;
	    	while(j<numberRefs && !encontradoOtroIgual){
	    		if (((String)refs[i].getProperty("PERVML_SERVICENAME")).equals(refsNoDuplicate[j].getProperty("PERVML_SERVICENAME")))
	    			encontradoOtroIgual=true;
	    	j++;	
	    	}
	    	
	    	
	    	if(!encontradoOtroIgual){
	    		refsNoDuplicate[numberRefs]=refs[i];
	    		numberRefs++;
	    	}
	    
	    }
		
		//obtenemos los pid
	    String [] services= new String[numberRefs];
		for (int i=0;i<numberRefs;i++)
			{
			services[i]=refsNoDuplicate[i].getProperty(org.osgi.framework.Constants.SERVICE_PID).toString();		
			}
		

		return services;
	}
	public String []getServices(){
		String filterString;
		filterString="(PERV-ML=COMPONENT)";
		return this.getFilteredServices(filterString);
		}
	public Object manageOperation(String PID, String Operation, Object []parameters){
		//si no podemos ejecutar aqui la reflexion por q es de tipo pervml componenent
		//copiaremos este metodo a pervml component y se ejecutara desde ahi
		PervMLComponent component  = (PervMLComponent) componentSearcher.getComponent(PervMLComponent.class.getName(),PID);
		Object res=null;
		  try{
		  	Class componentClass;
		  
	    	//System.out.println("Entra en try de runmethod");
	    //Method metodo=driverClass.getMethod(methodName,parameterTypes);
	    //res=metodo.invoke(driver,arguments);
		  	componentClass=component.getClass();
	    	  	//System.out.println("clase del driver: " + driverClass.getName());
	    	 Method[] metodos =componentClass.getMethods();
	    	
	    	 
	    	 for (int i=0;i<metodos.length;i++){
	    	 	//System.out.println("metodo:" + metodos[i].getName() + "num param: " + metodos[i].getParameterTypes().length);
	    	 	if (metodos[i].getName().equals(Operation) && metodos[i].getParameterTypes().length == parameters.length)
	    	 		{System.out.println("\n\nCoincide el metodo\n ");
	    	 		res=metodos[i].invoke(component,parameters);
	    	 		}
	    	 	//ojo podria haber sobrecarga de parametros, debemos determinar si son del mismo tipo, terminar
	    	 	//System.out.println("Se ejecuta el runmethod");
	    	 	
	    	 }
	 }catch(Exception e){System.out.print("Excepcion: " + e.getMessage());
	 						}
		
		return res;
			
	}
	
	public Map enabledOperations(String PID){
		PervMLComponent component  = (PervMLComponent) componentSearcher.getComponent(PervMLComponent.class.getName(),PID);
		return component.enabledOperations();
		}
		
	public Map getState(String PID){
		
		PervMLComponent component  = (PervMLComponent) componentSearcher.getComponent(PervMLComponent.class.getName(),PID);
		return component.getState();
		
    	}
	
	public Map getProperties(String PID){
		System.out.print("///get properties///");
		System.out.println("interfaz  "+PervMLComponent.class.getName()+"PID  "+PID);
		PervMLComponent component  = (PervMLComponent) componentSearcher.getComponent(PervMLComponent.class.getName(),PID);
		//String filterString="(service.pid="+PID+")";
		//PervMLComponent component  = (PervMLComponent) componentSearcher.getServiceReferenceFiltered(filterString)[0];
		return component.getProperties();
		
	}
	
	public ArrayList getLastLog(){
		LoggerListener loggerListener = (LoggerListener)componentSearcher.getComponent(LoggerListener.class.getName(),"loggerListener");
		return loggerListener.getErrors();
	}
	
}
