/*
 * Created on 08-abr-2005 by Carlos
 *
 */
package org.pervml.framework.WireHelper;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.Properties;
import java.util.Random;
import java.util.Set;
import java.util.TreeMap;

import org.osgi.framework.BundleContext;
import org.osgi.service.wireadmin.WireAdmin;
import org.pervml.framework.WireHelper.PervMLService.PervMLService;

import java.util.HashMap;

import javax.swing.JOptionPane;
;

/**
 * @author OOMETHOD
 *
 */
public abstract class PervMLComponent extends WireParticipant {
	//protected String ComponentId;
	protected String serviceName;
	protected String kindOfService;
	protected String location;
	protected HashMap operationsAndArguments=new HashMap();
	
	protected HashMap properties=new HashMap();
	//DTE
	protected HashMap STD = new HashMap();
	
	private boolean enableNotifications;
	
	//estado
	//derivado de las funciones que no tienen parametros y devuelven ditinto de void
	protected TreeMap state= new TreeMap();
	
	//estado del dte
	//el dte se encentra en un diccionario de diccionarios
	//existen formulas para derivar el estado de las for
	protected String STDState;
	
	public PervMLComponent(BundleContext c,String nComponentPID){
		super(c);
		enableNotifications();
		this.componentPID=nComponentPID;
		initializeProperties();
		setKindOfService();
		setInitialSTDState();
		initializeSTD();
		properties.put("serviceName",serviceName);
		properties.put("location",location);
		properties.put("kindOfService",kindOfService);
		initializeOperationsAndArguments();
		System.out.println("[PervMLComponent](constructor) Acabo de update previous");
		checkTriggers();
		setInitializePersitentVariables();
		
		this.state=getState();
		
	//al no haber estado definido daria error	STDState= getSTDState();
	}
	
	protected abstract void initializeProperties();
	protected abstract void setKindOfService();
	protected abstract void setInitialSTDState();
	
	protected abstract void setInitializePersitentVariables();
	protected abstract void initializeSTD();
	
	protected  void enableNotifications(){
		enableNotifications=true;
		
	}
	
	protected void disableNotificacions(){
		enableNotifications=false;
	}
	protected boolean changeState(){
		TreeMap newState=getState();
		if (state.equals(newState))
			return false;
		else 
		{
			state = newState;
			return true;
		}
	}
	
	public abstract TreeMap getState();
	
	public HashMap getProperties(){
		return properties;
	}
	
	
	public void manageUpdate(){
		System.out.println("[PervMLComponent](manageUpdate): Se puede notificar? "+enableNotifications);
		if (enableNotifications==true)
		{
		
	checkTriggers();
	System.out.println("[PervMLComponent](manageUpdate): Despues de checktriggers");
	System.out.println("[PervMLComponent](manageUpdate): Cantidad de consumidores: "+this.wiresConsumer.length+"de: "+ serviceName +"\n\n");
	//JOptionPane.showMessageDialog(null,serviceName +" Cantidad de consumers: "+ this.wiresConsumer.length+" pid del consumer:" + wiresConsumer[0].getProperties().get("wireadmin.pid"));
	
	if(changeState()==true)//si el estado ha cambiado y las notificaciones estaban habilitadas->notifico los cambios
		notifyConsumers();
	System.out.println("[PervMLComponent](manageUpdate): Despues de notifyConsumers");
	
	System.out.println("[PervMLComponent](manageUpdate): Acabo de update previous");
	}
	}
	
	public String getLocation(){
		return this.location;
	}
	public String getKindOfService(){
		return this.kindOfService;
	}
	public String getServiceName(){
		return this.serviceName;
	}
	
	
	
	public String getSTDState()//Se halla con las formulas
	{
		//		Comprobar si se satisface la formula del estado actual
		if(STDState!=null){
			System.out.println("[PervMLComponent](getSTDState): Estamos en el estado "+ STDState); 
		
		State STDStateInstance=(State)STD.get(this.STDState);
		State aux;
		ArrayList validSTDState = new ArrayList();
		
		//Estamos en el estado almacenado
		if (STDStateInstance.satisfy()) return this.STDState;
		
		//Buscamos en el o los estados en que estamos
		Iterator it=STD.values().iterator();
		
		while (it.hasNext()){
				aux=(State)it.next();
				if(aux.satisfy()){
					System.out.println("[PervMLComponent](getSTDState): Este estado se satisface "+ aux.name);
					validSTDState.add(aux);}
			}
		switch (validSTDState.size()){
		
			case 1: //Un estado v�lido
				return ((State)validSTDState.get(0)).getName();
				
			case 0: //Estado del DTE inconsistente
				this.logger.errorLog("PervMLComponent](getSTDState): Estado inconsistente: no se satisface ninguna de las formulas del DTE");	
				return null;
				
			default://Varios estados posibles->cogemos uno al azar
				Random r=new Random();
				return ((State)validSTDState.get(r.nextInt(validSTDState.size()))).getName();
			}
		
		}
		else 
			this.logger.errorLog("PervMLComponent](getSTDState): Se ha intentado recalcular el estado del DTE sin disponer de un estado inicial");	
			return null;
	}
	
	protected abstract void initializeOperationsAndArguments();
	
	public  HashMap enabledOperations(){
		STDState=getSTDState();
		State STDStateInstance=(State) STD.get(STDState);
		String enabledOperations []=STDStateInstance.getOperations();//Operaciones permitidas
		//actualState="OFF";
		HashMap enabledOperationsInformation=new HashMap();
		
		for (int i=0;i<enabledOperations.length;i++){
			if (this.operationsAndArguments.get(enabledOperations[i])!=null)
			enabledOperationsInformation.put(enabledOperations[i],this.operationsAndArguments.get(enabledOperations[i]));
		}
		
		return enabledOperationsInformation;
		
	}
	//public abstract void changeState(String operation);
	
	public void updateSTDState(String operation, HashMap parameters){
		System.out.println("[PervMLComponent](updateSTDState): Estado en el que estoy "+STDState);
		State STDStateInstance=(State) STD.get(STDState);
		STDState =STDStateInstance.getTransitedState(operation,parameters);
		System.out.println("[PervMLComponent](updateSTDState): operation: "+operation+" Estado al que cambia "+ STDState);
		
	}
	
	

	
}
