package org.pervml.UI.WebUI;






import org.osgi.framework.BundleContext;
import org.osgi.framework.BundleActivator;
import org.osgi.framework.ServiceReference;



import org.osgi.service.http.HttpContext;
import org.osgi.service.http.HttpService;


import javax.servlet.http.HttpServlet;

import org.osgi.util.tracker.ServiceTracker;
import org.osgi.framework.ServiceListener;
import org.osgi.framework.ServiceEvent;

/**
 * The main plugin class to be used in the desktop.
 */
public class Activator implements BundleActivator,ServiceListener {

	protected String servicesWebUIRoot;
	
	//Variables aadidas
	protected String PervMLServiceName;
	protected String UIalias="";
	protected String ListingAlias="";
	//fin aadidas
	
	//	Change this for every new WebUI
	protected String serviceServletPath = "";
	protected String serviceListingServletPath = "";
	protected String webUIPath = "";
	
	private ServiceTracker httpTracker = null;
	private HttpService httpService = null;
	protected BundleContext context = null;
	
	
	
	
	HttpContext httpContext;
	servletContext sc;
	
	public void start(BundleContext c) throws Exception {
		this.context = c;
		
		
		servicesWebUIRoot = "/web/services";
		
		serviceListingServletPath = servicesWebUIRoot+"/list";
		webUIPath=servicesWebUIRoot+"/webUI";
		
		this.getHttpService(context);
        
		if ( httpService  != null) 
        	{HttpContext httpContext= httpService.createDefaultHttpContext();
    		sc= new servletContext(httpContext);
	      	this.registerWebUI(context,httpService);
	      	registerResources();
        	}
        
		
        this.context.addServiceListener(this,"(objectclass="+HttpService.class.getName()+")");
        
     }
	

	//protected abstract void initialize();
	public void stop(BundleContext context) {
		this.getHttpService(context);
        if ( httpService  != null) 
        	this.unregisterWebUI(context,httpService);
       
	}
		
	public void serviceChanged(ServiceEvent event){
		if (event.getType() == ServiceEvent.REGISTERED) {
			
			try {
				httpService=(HttpService)this.context.getService(event.getServiceReference());
				httpContext = httpService.createDefaultHttpContext();
	    		sc= new servletContext(httpContext);
		      	this.registerWebUI(this.context,(HttpService)this.context.getService(event.getServiceReference()));
				registerResources();
			} catch (Exception e) {
				e.printStackTrace();
			}
			
		}
	}
	
	private void registerWebUI(BundleContext context, HttpService httpService) throws Exception{
	
       HttpServlet serviceListingWebServlet = new ServiceListing(context,this.servicesWebUIRoot,PervMLServiceName);
       httpService.registerServlet(serviceListingServletPath, serviceListingWebServlet,null,sc);//,null);
      System.out.println("PervML.WebUI: url of the http UI: " +serviceListingServletPath );
      HttpServlet WebUIServlet = new ServiceUI(context,this.servicesWebUIRoot,webUIPath);
      httpService.registerServlet(webUIPath, WebUIServlet,null,sc);
     
	}
	
	private void unregisterWebUI(BundleContext context, HttpService httpService){
		
	    httpService.unregister(this.serviceListingServletPath);
	   	
	}
	
	private void getHttpService(BundleContext context){
		
	
		
				if (this.httpTracker == null ){
							this.httpTracker = new ServiceTracker(context,HttpService.class.getName(),null);
							this.httpTracker.open();
		}
		
		Object [] services = this.httpTracker.getServices();
		
		if (!(services == null))
		{
	
		if (services[0].getClass().getName().equals("com.prosyst.mbs.impl.framework.ServiceReferenceImpl"))
				this.httpService = (HttpService) this.context.getService((ServiceReference) services[0]);
		else 
			this.httpService = (HttpService) services[0];
		}
		
	}
	
	 private void registerResources() {
	 	
        if (httpService!=null) {
            try {
                
            	httpService.registerResources(this.servicesWebUIRoot+"/resources","org/pervml/UI/WebUI/resources",sc);
            	
            }
            catch(Exception ex) {
                System.out.println("register resource: "+ex.getMessage());
            }
        }
    }
	
}
