/*
 * Created on 12-ene-2005
 */
package org.pervml.UI.WebUI;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import javax.servlet.ServletException;

//import org.osgi.framework.InvalidSyntaxException;
import org.osgi.framework.ServiceReference;
import org.osgi.framework.BundleContext;
import org.osgi.service.log.LogEntry;
import org.osgi.util.tracker.ServiceTracker;
import org.pervml.framework.WireHelper.Controler;
import org.pervml.framework.WireHelper.FrameworkSearcher;
import org.pervml.framework.WireHelper.LoggerListener;

import java.io.PrintWriter;
import java.io.IOException;


import java.sql.Time;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;
import java.util.TreeMap;

//Change this for every new WebUI


/**
 * @author javierm
 */
public class ServiceUI extends HttpServlet {
//Atributos del componente
	protected String kindOfService;
	protected String serviceName;
	protected String location;
	//Html de salida
	protected PrintWriter out;
	
//	Change this for every new WebUI
	protected String PervMLServiceName ;
	
	private BundleContext context;
	protected String listingServletPath;

	ServiceTracker driverTracker = null;
	
	FrameworkSearcher componentTracker=null;
	protected Controler controller=null;
	
	protected Map properties;
	protected Map state;
	protected Map enabledOperations;
	
	private String serviceServletPath;
	private String servicesWebUIRoot;
	private String selfURL;
	
	HttpSession session ;

	public ServiceUI(BundleContext bc, String servicesWebUIRoot,  String uriAlias) {
		this.context = bc;
		selfURL=uriAlias;
		componentTracker= new FrameworkSearcher(context);
		//PervMLServiceName=NewPervMLServiceName;
		listingServletPath = servicesWebUIRoot.concat("/list");
		System.out.println(PervMLServiceName);
		if (this.context==null) {System.out.println("es nulo");}
		//this.driverTracker = new ServiceTracker(this.context,PervMLServiceName,null);
		 System.out.println("servicesWebUIRoot: " +servicesWebUIRoot);
		 System.out.println("uriAlias: " + uriAlias);
		 this.servicesWebUIRoot=servicesWebUIRoot;
		 this.serviceServletPath=servicesWebUIRoot.concat("/".concat(uriAlias));
		
	}
	public String getserviceServletPath(){
		
		return this.serviceServletPath;
	}
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }

    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }

  

   
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
    	this.session = request.getSession(true);
    	
    	PervMLServiceName = request.getParameter("PERVMLSERVICENAME");
    	

    	if ( (PervMLServiceName != null) ) {
			
    		controller = (Controler)componentTracker.getComponent(Controler.class.getName(),"controller");
    		properties=controller.getProperties(PervMLServiceName);
		kindOfService=(String)properties.get("kindOfService");
		 serviceName=(String)properties.get("serviceName");
		 location=(String)properties.get("location");
		 
		 System.out.println("\n\n\n\n****************************\nserviceName: "+servicesWebUIRoot+"serviceName: "+serviceName);
    	} 
    	//String location = request.getParameter("location");
    	String operation = request.getParameter("operation");
    		
    	
    			
    	System.out.println("/*/*/*/OPERATION WEBUI: "+operation);
		if ( (operation != null) ) {
			enabledOperations=(Map)session.getAttribute("enabledOperations");
			Object parameters[]=getArguments(operation,request);
			this.controller.manageOperation(PervMLServiceName,operation,parameters);
		}			
		response.setContentType("text/html");
        out = response.getWriter();
        
        this.printTop(out);
        
        printErrors();
        //this.printServiceData(out,location);
        
        printHeader();
        state=this.controller.getState(PervMLServiceName);
        
        this.session.setAttribute("enabledOperations",this.controller.enabledOperations(PervMLServiceName));
        enabledOperations=(Map)session.getAttribute("enabledOperations");
        this.printServiceState(properties);
        this.printSeparation();
        this.printServiceState(state);
        this.printSeparation();
        
        this.printServiceOperations(location,enabledOperations);
       // this.printSeparation();
       
        this.printBottom(out);
        
        out.close();
		
    }
    
    /**
	 * 
	 */
	private void printHeader() {
		out.println(" <div class=\"content\">");
    	out.println( "   <div class=\"postbox\">");
    	out.println(  "     <div id=\"160\">&nbsp;</div>");
    	out.println( " <div class=\"posttitle\">"+ serviceName  + "@" +location + "</div>");

    	out.println( " <div class=\"postext\">");
    	out.println("  <table align=\"center\" width=\"90%\" cellpadding=\"3px\">");
    			        
		
	}
	/**
	 * 
	 	 */
	private void printErrors() {
		LoggerListener loggerListener = (LoggerListener)componentTracker.getComponent(LoggerListener.class.getName(),"loggerListener");
		ArrayList errors = loggerListener.getErrors();
		if (errors.size()>0)
		{
		//	out.println(" <div class=\"content\">");
	    //	out.println( "   <div class=\"postbox\">");
	    	//out.println(  "     <div id=\"160\">&nbsp;</div>");
			out.println("<div class=\"content\">");
			out.println("<div class=\"postbox\">");
			out.println("<div id=\"160\">&nbsp;</div>");
	    		
	    					
			out.println("<div class=\"posttitle\"><b>ERRORS:</b></div>");
			out.println( " <div class=\"postext\">");
			Iterator it = errors.iterator();
			out.println(" <table align=\"center\" width=\"90%\" cellpadding=\"3px\">");
			while (it.hasNext()){
				LogEntry entry  = (LogEntry) it.next();
				Time time= new Time(entry.getTime());
				
				out.println("<tr>"+
						  "<td width=\"20%\" bgcolor=\"92B0BC\" >"+
						"	  <div class=\"celltitle\">"+"Time:"+ ":</div>"+
						"  </td>"+
						"  <td>"+
						time.toString()+
						"  </td>"+
					"	</tr>");
				//out.print("<BR><BR><b>Time: "+time.toString()+"</b>");
				out.println("<tr>"+
						  "<td width=\"20%\" bgcolor=\"92B0BC\" >"+
						"	  <div class=\"celltitle\">"+"Message:"+ ":</div>"+
						"  </td>"+
						"  <td>"+
						entry.getMessage()+
						"  </td>"+
					"	</tr>");
				out.println("<tr>"+
						  "<td width=\"20%\" >"+
						
						"  </td>"+
						"  <td>"+
						
						"  </td>"+
					"	</tr>");
				out.println("<tr>"+
						  "<td width=\"20%\" >"+
						
						"  </td>"+
						"  <td>"+
						
						"  </td>"+
					"	</tr>");
				//out.print("<BR><b>Message: "+entry.getMessage()+" </b>");
			   }
			out.println("</table>");
			
			out.println("</div> </div></div>");
		}
		
	}
	/**
	 * @param operation
	 * @return
	 */
	private Object[] getArguments(String operation,HttpServletRequest request) {
		Map arguments=(Map)this.enabledOperations.get(operation);
		String nameParameter;
		String typeParameter;
		
		if (arguments!=null) System.out.println("arguments no es null");
		Set keys=arguments.keySet();//Nombres de los argumentos
		
		System.out.println("-*-*-*-/////Numero de argumentos: "+ keys.size() );
		Object res[]=new Object[keys.size()];
		Iterator it=keys.iterator();
		int i=0;
		while(it.hasNext()){
			nameParameter=it.next().toString();
			typeParameter=(arguments.get(nameParameter)).toString();
			System.out.println("nombre parm "+ nameParameter + "  tipo param" + typeParameter);
			if(typeParameter.equals("int"))	
				res[i]=new Integer(request.getParameter(nameParameter));
			else if (typeParameter.equals("String"))
				res[i]=(request.getParameter(nameParameter)).toString();
		i++;
		}
		return res;
	}
	protected  void printServiceState(Map dictionary){
//    	this.properties=this.service.getProperties();
		Set dynamicProperties=dictionary.keySet();
    	Object dynamicPropertiesArray[]=dynamicProperties.toArray();
    	for(int i=0;i<dynamicPropertiesArray.length;i++){
    		
    		printServiceStateRow((String)dynamicPropertiesArray[i],(String)dictionary.get(dynamicPropertiesArray[i]));
    	}
    	
    	
    	//this.printServiceStateRow("Estado",(String)properties.keySet()..get("State"));
    }
    
    
    private void printSeparation(){
    	out.println(" </table> "+
			"<hr/>"+
			 "<table align=\"center\" width=\"90%\" cellpadding=\"3px\">");
    
    }
    private void printTop(PrintWriter out){
    	out.println("<html>" + 
    			"<head>" + 
				"<title>Service Admin</title>" +
				"<link type=\"text/css\" rel=\"stylesheet\" href=\""+servicesWebUIRoot+"/resources/style.css\"/>"+
			"</head>"+
			"<body>"+
			   "<div class=\"container\">"+
			      "<div class=\"header\">"+
				     " <div><b>System Management</b></div>"+
			        "<span class=\"explain\"></span>"+
			      "</div>"+
				  "<div class=\"col\">"+ 
			        "<div class=\"colsection\">"+
			         "<div class=\"sectiontitle\">"+
					  "<h5>Access services</h5>"+
			          "</div>"+
			          "<div class=\"setcontent\">"+
					  "<b><font color=\"92B0BC\">&gt;&gt;</font></b> <a href=\""+ listingServletPath + "?searchingType=KIND&searchingValue=ALL"+"\">by kind of service</a><br>"+
					  "<b><font color=\"92B0BC\">&gt;&gt;</font></b> <a href=\""+ listingServletPath + "?searchingType=LOCATION&searchingValue=ALL"+"\">by location</a><br>"+
					  "<b><font color=\"92B0BC\">&gt;&gt;</font></b> <a href=\""+ listingServletPath + "/list?searchingType=ALL"+"\">all services</a><br>"+
					  "<b><font color=\"92B0BC\">&gt;&gt;</font></b> <a href=\""+ listingServletPath + "?searchingType=SEARCHING&searchingValue=ALL"+"\">searching</a><br>"+
				  "</div>"+
			        "</div>"+
			      "</div>");
    	
    	

		//out.println  ("<table align=\"center\" width=\"90%\" cellpadding=\"3px\">");
/*		"	<tr>"+
		"	  <td width=\"20%\" bgcolor=\"92B0BC\" >"+
		"		  <div class=\"celltitle\"> Service:</div>"+
		"	  </td>"+
			"  <td>"+
			kindOfService+
			"  </td>"+
			"</tr>"+
			"<tr>"+
			"  <td width=\"20%\" bgcolor=\"92B0BC\" >"+
			  "<div class=\"celltitle\"> Location:</div>"+
			"  </td>"+
			"  <td>"+
				location +
			 " </td>"+
			"</tr>"+
			
		"</table>"+
		"<hr/>"+
		"  <table align=\"center\" width=\"90%\" cellpadding=\"3px\">");
		*/
    	//out.println("  <table align=\"center\" width=\"90%\" cellpadding=\"3px\">");
        
    }
    
    
    protected void printServiceStateRow(String property, String value){
    	out.println("<tr>"+
		  "<td width=\"20%\" bgcolor=\"92B0BC\" >"+
		"	  <div class=\"celltitle\">"+property+ ":</div>"+
		"  </td>"+
		"  <td>"+
		value+
		"  </td>"+
	"	</tr>");
    
    }
    private void printBottom(PrintWriter out){		 
    	out.println(" </table>"+
		 " <div class=\"postfooter\">"+
	"	  <!--div align=\"center\">Select a service.</div-->"+
     "     </div>"+
    "    </div>"+
   "   </div>"+
  "    <div class=\"footer\">"+
   "   </div>"+
  "  </div>"+
  "</body>"+
"</html>");
    	
    }
    
   // protected abstract void printServiceData(PrintWriter out, String location);

   
//  Change this for every new WebUI
    protected void printServiceOperations(String location,Map enabledOperations){
    	Iterator it=enabledOperations.keySet().iterator();
    	while (it.hasNext()){
    		
    		String operation=it.next().toString();
    		System.out.println("!!!!!OPERACION: "+ operation);
    		//out.print(operation);
    		//out.println("<div class=\"col\">"+  "<div class=\"colsection\">"+	   "<div class=\"sectiontitle\">"+ "<h5>"+operation+"</h5>"+ "</div>");
    		out.println("<div class=\"sectiontitle\">"+ "<h5>"+operation+"</h5>"+ "</div>");
    		out.println("  <table align=\"center\" width=\"90%\" cellpadding=\"3px\">");
    		out.println("<form method=\"GET\" action=\""+selfURL+"\">"+ "<input type=\"hidden\" name=\"operation\" value=\""+operation+"\"/>"+ "<input type=\"hidden\" name=\"PERVMLSERVICENAME\" value=\""+PervMLServiceName+"\"/>");
    		
    		
    		Map arguments=(Map)enabledOperations.get(operation);
    		
    		Iterator itArgs=arguments.keySet().iterator();
    		while(itArgs.hasNext()){
    			String argumentName=itArgs.next().toString();
    			String argumentType=arguments.get(argumentName).toString();
    			printArgumentRow(argumentName,argumentType);
    			
    		}
    		out.println("<BR><input type=\"submit\" value=\"OK\"/></form>");
    		//out.println("</div>"+ "</div>"+   "</div>");
    	}
    		
    	
    	
    }
    
    /**
 * @param argumentName
 * @param argumentType
 */
private void printArgumentRow(String argumentName, String argumentType) {
		  	
	
	if(argumentType.equals("String"))
		printString(argumentName);
	else if (argumentType.equals("int"))
		printInt(argumentName);
	
}
	 
    protected void printInt(String nameArg){
    	
    	out.print("<BR><BR><b>"+nameArg+": </b><input type=\"TEXT\" name="+nameArg+" value=\""+""+"\"/>");
   	
    	 }
    
    protected void printString(String nameArg){
    	out.print("<BR><BR><b>"+nameArg+": </b><input type=\"TEXT\" name="+nameArg+" value=\""+""+"\"/>");
        }
    
    private ServiceReference getPervMLService(String location){
    	System.out.println("entra");
    	this.driverTracker.open();
    	System.out.println("abre");
    	ServiceReference [] selected = this.driverTracker.getServiceReferences();
    	this.driverTracker.close();
    	
		int nSelected = 0;
		if ( selected != null) nSelected = selected.length;
		System.out.println(nSelected);
		for (int i = 0; i < nSelected; i++) {
			System.out.println((String) selected[i].getProperty("PervML_Service"));
			System.out.println("deberia"+PervMLServiceName);
			System.out.println((String) selected[i].getProperty("PervML_Location"));
			System.out.println("deberia"+location);
			if ( (PervMLServiceName == ((String) selected[i].getProperty("PervML_Service"))) &&
				 ( location.equals(((String) selected[i].getProperty("PervML_Location"))))
				 ){
				System.out.println("no null");
				return selected[i];
			}
		}
		System.out.println("null");
		return null;

    }
	
}
