package org.pervml.application.services.Lighting;

import org.pervml.framework.WireHelper.PervMLComponent;
import org.pervml.framework.WireHelper.State;

import org.osgi.framework.BundleContext;
import java.util.HashMap;
import java.util.TreeMap;

public abstract class GenericComponent extends PervMLComponent implements Interface {

	public GenericComponent(BundleContext c, String componentPid){
			super(c,componentPid);
	}
	
	// Initialization
	protected void setKindOfService(){
		this.kindOfService = "Lighting";
	}
	
	protected void setInitialSTDState(){
		this.STDState="Off";		
	}
	
	protected void initializeSTD(){
		this.STD.put("Off",new State_Off());  
		 this.STD.put("On",new State_On());
	}
	
	protected void setInitializePersitentVariables(){
	  // TODO
	}
	
	protected void initializeOperationsAndArguments(){
	  HashMap arguments_switchOn = new HashMap();
		operationsAndArguments.put("switchOn",arguments_switchOn);		
		
		HashMap arguments_switchOff = new HashMap();
		operationsAndArguments.put("switchOff",arguments_switchOff);		
		
		
	}
	
		
	// Service related operations
	protected abstract void Implementation_switchOn()  ;

	public void switchOn()  {
	  
	
	    if(pre_switchOn()){
			try{
				disableNotificacions();
				
				Implementation_switchOn();
				if (post_switchOn()){
   					HashMap parameters = null;
					
					this.updateSTDState("switchOn",parameters);
					}
			} finally {
				enableNotifications();
				
				if( changeState() == true )
							notifyConsumers();
				
			}
			
		}
	}

	public boolean pre_switchOn(){
		// Expression: 
		return true;	
	}    
	
	public boolean post_switchOn(){
		// Expression: 
		return true;	
	} 

protected abstract void Implementation_switchOff()  ;

	public void switchOff()  {
	  
	
	    if(pre_switchOff()){
			try{
				disableNotificacions();
				
				Implementation_switchOff();
				if (post_switchOff()){
   					HashMap parameters = null;
					
					this.updateSTDState("switchOff",parameters);
					}
			} finally {
				enableNotifications();
				
				if( changeState() == true )
							notifyConsumers();
				
			}
			
		}
	}

	public boolean pre_switchOff(){
		// Expression: 
		return true;	
	}    
	
	public boolean post_switchOff(){
		// Expression: 
		return true;	
	} 

protected abstract boolean Implementation_isLighting()  ;

	public boolean isLighting()  {
	  boolean returnValue;
	
	    if(pre_isLighting()){
			try{
				disableNotificacions();
				returnValue = 
				Implementation_isLighting();
				if (post_isLighting()){
   					HashMap parameters = null;
					
					this.updateSTDState("isLighting",parameters);
					}
			} finally {
				enableNotifications();
				
			}
			return returnValue;
		}else return false;

	}

	public boolean pre_isLighting(){
		// Expression: 
		return true;	
	}    
	
	public boolean post_isLighting(){
		// Expression: 
		return true;	
	} 



    public TreeMap getState() {
		TreeMap hashMapComparable= new TreeMap();
		
		hashMapComparable.put("isLighting",new Boolean(isLighting()).toString());

		return hashMapComparable;
	}
    
    

	private class State_Off extends State {
	
		public State_Off(){
			super();
			this.name="Off";
			
					DestinationTransition [] transition_switchOn = {
			 new switchOn()			};				
			transitions.put("switchOn",transition_switchOn);			
			  
			
					DestinationTransition [] transition_isLighting = {
			 new isLighting()			};				
			transitions.put("isLighting",transition_isLighting);			
			  
			
		}
	
		public boolean satisfy() {
			boolean returnValue = true;
			// ValidityExpression: 
			return returnValue;
		}
	
	    
		public class isLighting extends DestinationTransition {
			public isLighting(){
				super();
				finalState="Off";
			}
			
			public boolean guardCondition(HashMap parameters)
			{
				boolean returnValue = true;
				
								
				return returnValue;
			}
		}
		
		public class switchOn extends DestinationTransition {
			public switchOn(){
				super();
				finalState="On";
			}
			
			public boolean guardCondition(HashMap parameters)
			{
				boolean returnValue = true;
				
								
				return returnValue;
			}
		}
		
	}
    

	private class State_On extends State {
	
		public State_On(){
			super();
			this.name="On";
			
			
					DestinationTransition [] transition_switchOff = {
			 new switchOff()			};				
			transitions.put("switchOff",transition_switchOff);			
			  
					DestinationTransition [] transition_isLighting = {
			 new isLighting()			};				
			transitions.put("isLighting",transition_isLighting);			
			  
			
		}
	
		public boolean satisfy() {
			boolean returnValue = true;
			// ValidityExpression: 
			return returnValue;
		}
	
	    
		public class isLighting extends DestinationTransition {
			public isLighting(){
				super();
				finalState="On";
			}
			
			public boolean guardCondition(HashMap parameters)
			{
				boolean returnValue = true;
				
								
				return returnValue;
			}
		}
		
		public class switchOff extends DestinationTransition {
			public switchOff(){
				super();
				finalState="Off";
			}
			
			public boolean guardCondition(HashMap parameters)
			{
				boolean returnValue = true;
				
								
				return returnValue;
			}
		}
		
	}


}
  
