package org.pervml.application.services.LightingByPresence;

import org.pervml.framework.WireHelper.PervMLComponent;
import org.pervml.framework.WireHelper.State;

import org.osgi.framework.BundleContext;
import java.util.HashMap;
import java.util.TreeMap;

public abstract class GenericComponent extends PervMLComponent implements Interface {

	public GenericComponent(BundleContext c, String componentPid){
			super(c,componentPid);
	}
	
	// Initialization
	protected void setKindOfService(){
		this.kindOfService = "LightingByPresence";
	}
	
	protected void setInitialSTDState(){
		this.STDState="Disabled";		
	}
	
	protected void initializeSTD(){
		this.STD.put("Enabled",new State_Enabled());  
		 this.STD.put("Disabled",new State_Disabled());
	}
	
	protected void setInitializePersitentVariables(){
	  // TODO
	}
	
	protected void initializeOperationsAndArguments(){
	  HashMap arguments_enable = new HashMap();
		operationsAndArguments.put("enable",arguments_enable);		
		
		HashMap arguments_disable = new HashMap();
		operationsAndArguments.put("disable",arguments_disable);		
		
		
	}
	
		
	// Service related operations
	protected abstract void Implementation_enable()  ;

	public void enable()  {
	  
	
	    if(pre_enable()){
			try{
				disableNotificacions();
				
				Implementation_enable();
				if (post_enable()){
   					HashMap parameters = null;
					
					this.updateSTDState("enable",parameters);
					}
			} finally {
				enableNotifications();
				
				if( changeState() == true )
							notifyConsumers();
				
			}
			
		}
	}

	public boolean pre_enable(){
		// Expression: 
		return true;	
	}    
	
	public boolean post_enable(){
		// Expression: 
		return true;	
	} 

protected abstract void Implementation_disable()  ;

	public void disable()  {
	  
	
	    if(pre_disable()){
			try{
				disableNotificacions();
				
				Implementation_disable();
				if (post_disable()){
   					HashMap parameters = null;
					
					this.updateSTDState("disable",parameters);
					}
			} finally {
				enableNotifications();
				
				if( changeState() == true )
							notifyConsumers();
				
			}
			
		}
	}

	public boolean pre_disable(){
		// Expression: 
		return true;	
	}    
	
	public boolean post_disable(){
		// Expression: 
		return true;	
	} 

protected abstract boolean Implementation_isEnabled()  ;

	public boolean isEnabled()  {
	  boolean returnValue;
	
	    if(pre_isEnabled()){
			try{
				disableNotificacions();
				returnValue = 
				Implementation_isEnabled();
				if (post_isEnabled()){
   					HashMap parameters = null;
					
					this.updateSTDState("isEnabled",parameters);
					}
			} finally {
				enableNotifications();
				
			}
			return returnValue;
		}else return false;

	}

	public boolean pre_isEnabled(){
		// Expression: 
		return true;	
	}    
	
	public boolean post_isEnabled(){
		// Expression: 
		return true;	
	} 



    public TreeMap getState() {
		TreeMap hashMapComparable= new TreeMap();
		
		hashMapComparable.put("isEnabled",new Boolean(isEnabled()).toString());

		return hashMapComparable;
	}
    
    

	private class State_Disabled extends State {
	
		public State_Disabled(){
			super();
			this.name="Disabled";
			
					DestinationTransition [] transition_enable = {
			 new enable()			};				
			transitions.put("enable",transition_enable);			
			  
			
					DestinationTransition [] transition_isEnabled = {
			 new isEnabled()			};				
			transitions.put("isEnabled",transition_isEnabled);			
			  
			
		}
	
		public boolean satisfy() {
			boolean returnValue = true;
			// ValidityExpression: 
			return returnValue;
		}
	
	    
		public class isEnabled extends DestinationTransition {
			public isEnabled(){
				super();
				finalState="Disabled";
			}
			
			public boolean guardCondition(HashMap parameters)
			{
				boolean returnValue = true;
				
								
				return returnValue;
			}
		}
		
		public class enable extends DestinationTransition {
			public enable(){
				super();
				finalState="Enabled";
			}
			
			public boolean guardCondition(HashMap parameters)
			{
				boolean returnValue = true;
				
								
				return returnValue;
			}
		}
		
	}
    

	private class State_Enabled extends State {
	
		public State_Enabled(){
			super();
			this.name="Enabled";
			
			
					DestinationTransition [] transition_disable = {
			 new disable()			};				
			transitions.put("disable",transition_disable);			
			  
					DestinationTransition [] transition_isEnabled = {
			 new isEnabled()			};				
			transitions.put("isEnabled",transition_isEnabled);			
			  
			
		}
	
		public boolean satisfy() {
			boolean returnValue = true;
			// ValidityExpression: 
			return returnValue;
		}
	
	    
		public class isEnabled extends DestinationTransition {
			public isEnabled(){
				super();
				finalState="Enabled";
			}
			
			public boolean guardCondition(HashMap parameters)
			{
				boolean returnValue = true;
				
								
				return returnValue;
			}
		}
		
		public class disable extends DestinationTransition {
			public disable(){
				super();
				finalState="Disabled";
			}
			
			public boolean guardCondition(HashMap parameters)
			{
				boolean returnValue = true;
				
								
				return returnValue;
			}
		}
		
	}


}
  
