package es.upv.pros.tunnel.abstractClasses;

import java.util.Hashtable;

import es.upv.pros.tunnel.interfaces.IDevice;

public abstract class AbstractDevice implements IDevice {
	
	
	Hashtable <String, String>props=new Hashtable<String, String>();
	Hashtable <String, Object>otherProperties=new Hashtable<String, Object>();
	public Hashtable<String, Hashtable<Boolean,String>>states=new Hashtable<String, Hashtable<Boolean,String>>();
	
	public AbstractDevice(String address, String description,String deviceType, String deviceSubType, String iD, String location, String manufacturer, String model, String name, String profile, String serialNumber, String tunnel, String dataType, Hashtable<String, Object> otherProperties)
	{
		this.setAddress(address);
		this.setDescription(description);
		this.setDeviceType(deviceType);
		this.setID(iD);
		this.setSubType(deviceSubType);
		this.setLocation(location);
		this.setManufacturer(manufacturer);
		this.setModel(model);
		this.setName(name);
		this.setProfile(profile);
		this.setSerialNumber(serialNumber);
		this.setTunnel(tunnel);
		this.setDataType(dataType);
		this.setOtherProperties(otherProperties);
		fillStates();
	}
	
	public AbstractDevice(Hashtable<String,String> properties, Hashtable<String, Object>otherProperties)
	{
		this.props = properties; 
		this.setOtherProperties(otherProperties);
		fillStates();
		
		
	}
	
	public String getAddress() {
		return this.props.get(DEVICE_ADDRESS);
	}

	public String getDescription() {
		return this.props.get(DEVICE_DESCRIPTION);
	}

	public String getDeviceType() {
		return this.props.get(DEVICE_TYPE);
	}

	public String getID() {
		return this.props.get(DEVICE_ID);
	}

	public String getLocation() {
		return this.props.get(DEVICE_LOCATION);
	}

	public String getManufacturer() {
		return this.props.get(DEVICE_MANUFACTURER);
	}

	public String getModel() {
		return this.props.get(DEVICE_MODEL);
	}

	public String getName() {
		return this.props.get(DEVICE_NAME);
	}

	public String getProfile() {
		return this.props.get(DEVICE_PROFILE);
	}

	public String getSerialNumber() {
		return this.props.get(DEVICE_SERIAL_NUMBER);
	}

	public String getTunnel() {
		return this.props.get(DEVICE_TUNNEL);
		
	}

	public void setAddress(String address) {
		props.put(IDevice.DEVICE_ADDRESS, address);
	}

	public void setDescription(String description) {
		props.put(IDevice.DEVICE_DESCRIPTION, description);
	}

	public void setDeviceType(String deviceType) {
		props.put(IDevice.DEVICE_TYPE, deviceType);
	}

	public void setID(String iD) {
		props.put(IDevice.DEVICE_ID, iD);
	}

	public void setLocation(String location) {
		props.put(IDevice.DEVICE_LOCATION, location);
	}

	public void setManufacturer(String manufacturer) {
		props.put(IDevice.DEVICE_MANUFACTURER, manufacturer);
	}

	public void setModel(String model) {
		props.put(IDevice.DEVICE_MODEL, model);
	}

	public void setName(String name) {
		props.put(IDevice.DEVICE_NAME, name);
	}

	public void setProfile(String profile) {
		props.put(IDevice.DEVICE_PROFILE, profile);
	}

	public void setSerialNumber(String serialNumber) {
		props.put(IDevice.DEVICE_SERIAL_NUMBER, serialNumber);
	}

	public void setTunnel(String tunnel) {
		props.put(IDevice.DEVICE_TUNNEL, tunnel);
	}

	public String getDataType() {
		return this.props.get(DEVICE_DATA_TYPE);
	}

	public void setDataType(String dataType) {
		props.put(IDevice.DEVICE_DATA_TYPE, dataType);
	}
	
	public Hashtable<String, String> getProps(){
		return this.props;
	}

	public Hashtable<String, Object> getOtherProperties() {
		return otherProperties;
	}

	public void setOtherProperties(Hashtable<String, Object> otherProperties) {
		this.otherProperties=otherProperties;	
	}
	
	public void setSubType(String subType){
		this.props.put(DEVICE_SUBTYPE, subType);
	}
	
	public String getSubType(){
		return this.props.get(DEVICE_SUBTYPE);
	}
	public abstract void fillStates();
}
