package es.upv.pros.tunnel.classes;

import java.util.Calendar;

/**
 * This class represents a new data received from a sensor
 * @author ProS - UPV
 *
 */
public class NewDataReceived {

	
		private String address;
		private String timeStamp;
		private Object data;
		private Class dataType;
		
		public NewDataReceived(String  address, Object data, Class dataType) {
			this.address=address;
			this.data=data;
			this.timeStamp=Calendar.getInstance().getTime().toString();
			this.dataType=dataType;
		}
		
		/**
		 * Returns a String representing the address of the sensor that has provided the data 
		 * @return The address as a String
		 */
		public String getAddress() {
			return address;
		}
		
		/**
		 * Returns the time stamp when the data has been provided by the sensor
		 * @return The data as a String
		 */
		public String getTimeStamp() {
			return timeStamp;
		}
		
		/**
		 * Returns the data provided by the sensor
		 * @return the data as a Object
		 */
		public Object getData() {
			return data;
		}
		
		/**
		 * Return the Class of the data provided the sensor 
		 * @return The Class of the data
		 */
		public Class getDataType() {
			return dataType;
		}
		
		

	}
