package es.upv.pros.tunnel.classes;

import java.util.HashMap;
import java.util.Hashtable;

import org.osgi.framework.BundleContext;
import org.osgi.framework.InvalidSyntaxException;
import org.osgi.service.wireadmin.Consumer;
import org.osgi.service.wireadmin.Producer;
import org.osgi.service.wireadmin.Wire;
import org.osgi.service.wireadmin.WireAdmin;
import org.osgi.service.wireadmin.WireConstants;

import es.upv.pros.tunnel.abstractClasses.AbstractDevice;
import es.upv.pros.tunnel.interfaces.ISensor;
import es.upv.pros.tunnel.interfaces.TunnelConstants;

public class Sensor extends AbstractDevice implements ISensor, Producer , Consumer{


	BundleContext context;
	NewDataReceived lastData=null;
	String notificationMode;
	
	public Sensor(BundleContext context, String address, String description,
			String deviceType,String deviceSubType, String iD, String location, String manufacturer,
			String model, String name, String profile, String serialNumber,
			String tunnel, String dataType,String notificationMode, Hashtable otherProperties) {
		super(address, description, deviceType, deviceSubType, iD, location, manufacturer,
				model, name, profile, serialNumber, tunnel, dataType, otherProperties);
		Hashtable props=super.getProps();
		props.put(TunnelConstants.SERVICE_CLASS, ISensor.class.getName());
		props.put(WireConstants.WIREADMIN_PRODUCER_FLAVORS, new Class[]{NewDataReceived.class, Object.class});
		//props.put(WireConstants.WIREADMIN_CONSUMER_FLAVORS, new Class[]{NewDataReceived.class, Object.class});
		props.put(org.osgi.framework.Constants.SERVICE_PID, iD);
		context.registerService(ISensor.class.getName(), this, props);
		context.registerService(Producer.class.getName(), this, props);
		//context.registerService(Consumer.class.getName(), this, props);

		this.context=context;
		this.notificationMode=notificationMode;
	}
	
	public Sensor(BundleContext context, Hashtable<String,String> properties, Hashtable<String, Object> otherProperties, String notificationMode){
		super(properties,otherProperties);
		Hashtable sensorProps=super.getProps();
		sensorProps.put(TunnelConstants.SERVICE_CLASS, ISensor.class.getName());
		
		//NACHO
		//sensorProps.put(WireConstants.WIREADMIN_PRODUCER_FLAVORS, new Class[]{NewDataReceived.class});
		
		sensorProps.put(WireConstants.WIREADMIN_PRODUCER_FLAVORS, new Class[]{NewDataReceived.class, Object.class});
		//(sensorProps.put(WireConstants.WIREADMIN_CONSUMER_FLAVORS, new Class[]{NewDataReceived.class, Object.class});
		sensorProps.put(org.osgi.framework.Constants.SERVICE_PID, super.getID());
		context.registerService(ISensor.class.getName(), this, sensorProps);
		context.registerService(Producer.class.getName(), this, sensorProps);
		//context.registerService(Consumer.class.getName(), this, sensorProps);

		this.context=context;
		this.notificationMode=notificationMode;
	}
	
	//TODO: ES POT SOBREESCRIURE SI VOLEM FER UNA ALTRA COSA
	public void newDataReceived(NewDataReceived data){
		lastData=data;
		System.out.println("\n\nNEW DATA: "+data.getData().toString()+"\n\n");
		WireAdmin wa=(WireAdmin)this.context.getService(this.context.getServiceReference(WireAdmin.class.getName()));
		try {
			Wire[] myW=wa.getWires("("+WireConstants.WIREADMIN_PRODUCER_PID+"="+this.getID()+")");
			consumersConnected(myW);
		} 
		catch (InvalidSyntaxException e) 
		{
			e.printStackTrace();
		}
	}

	public void consumersConnected(Wire[] wires) {
		if(wires!=null){
			System.out.println("WIRES: "+wires.length);
			for (int i = 0; i < wires.length; i++) {
				wires[i].update(polled(wires[i]));
			}
		}
		else{
			System.out.println("NO CONSUMERS");
		}
	}

	public Object polled(Wire wire) {
		//NACHO
		//return lastData;
		return new HashMap();
	}

	public String getNotificationMode() {
		return this.notificationMode;
	}

	public void setNotificationMode(String notificationMode) {
		this.notificationMode=notificationMode;
		
	}

	public Object getState() {
		if(lastData==null){
			return null;
		}
		else{
			return lastData.getData();
		}
	}

	@Override
	public void fillStates() {
		
	}

	public void producersConnected(Wire[] wires) {
	
	}

	public void updated(Wire wire, Object value) {
		
		
	}

}
