package es.upv.pros.tunnel.interfaces;

/**
 * Services registered under this interface are expected to manage Vertical Movement devices such as blinds
 * @author ProS - UPV
 *
 */
public interface IActuatorVerticalMovement extends IDevice {
public static final String IVMDEVICE_SECOND_ADDRESS="es.upv.pros.IVMDeviceConstants.ivmdevice-second-address";
	/**
	 * Moves up the device
	 */
	public void moveUp();
	/**
	 * Moves down the device
	 */
	public void moveDown();
	/**
	 * Stops the engine
	 * @throws Exception if the stop address has not been provided to the other properties hashtable of the device
	 */
	public void stop() throws Exception;
	
}
