package es.upv.pros.tunnel.interfaces;

import es.upv.pros.tunnel.classes.NewDataReceived;

/**
 * Services registered under this interface are expected to manage sensor devices
 * @author ProS - UPV
 *
 */
public interface ISensor extends IDevice {

	public static final String NOTIFY_ALWAYS="es.upv.pros.ISensorConstants.notify-always";
	public static final String NOTIFY_ON_CHANGE="es.upv.pros.ISensorConstants.notify-on-change";
	/**
	 * This method is executed when a new data of the given sensor is received 
	 * @param data the new data.
	 */
	public void newDataReceived(NewDataReceived data);
	
	public void setNotificationMode(String notificationMode);
	
	public String getNotificationMode();

}
