package es.upv.pros.tunnel.calimero.impl;

import java.util.Hashtable;

import org.osgi.framework.BundleContext;
import org.osgi.framework.InvalidSyntaxException;
import org.osgi.framework.ServiceReference;

import es.upv.pros.tunnel.abstractClasses.AbstractDevice;
import es.upv.pros.tunnel.interfaces.IActuatorPulse;
import es.upv.pros.tunnel.interfaces.ITunnelWriter;
import es.upv.pros.tunnel.interfaces.IActuatorVerticalMovement;
import es.upv.pros.tunnel.interfaces.TunnelConstants;

public class CalimeroPulse extends AbstractDevice implements IActuatorPulse {

	ITunnelWriter myTunnel;
	
	public CalimeroPulse(BundleContext context,String address, String description,String deviceType, String deviceSubType, String iD, String location, String manufacturer, String model, String name, String profile, String serialNumber, String tunnel, String dataType, Hashtable<String, Object> otherProperties){
		super(address, description, deviceType, deviceSubType, iD, location, manufacturer, model, name, profile, serialNumber, tunnel, dataType, otherProperties);
		try {
			ServiceReference[] sr=context.getServiceReferences(ITunnelWriter.class.getName(), "("+TunnelConstants.TUNNEL_NAME+"="+this.getTunnel()+")");
			if(sr!=null&&sr.length>0){
				myTunnel=(ITunnelWriter) context.getService(sr[0]);
			}
		} catch (InvalidSyntaxException e) {
			e.printStackTrace();
		}
		
	}
	
	public CalimeroPulse (BundleContext context, Hashtable<String, String> props, Hashtable<String,Object>otherProperties){
		super(props,otherProperties);
		try {
			ServiceReference[] sr=context.getServiceReferences(ITunnelWriter.class.getName(), "("+TunnelConstants.TUNNEL_NAME+"="+this.getTunnel()+")");
			if(sr!=null&&sr.length>0){
				myTunnel=(ITunnelWriter) context.getService(sr[0]);
			}
		} catch (InvalidSyntaxException e) {
			e.printStackTrace();
		}
	}

	public void pulse() {
		myTunnel.writeBoolean(this.getAddress(), true);
		
	}

	public Object getState() {
		return myTunnel.getActuatorState(this.getAddress());
	}

	@Override
	public void fillStates() {
	}

}
