package es.upv.pros.tunnel.calimero.impl;

import java.util.Hashtable;

import org.osgi.framework.BundleContext;
import org.osgi.framework.InvalidSyntaxException;
import org.osgi.framework.ServiceReference;

import com.sun.org.apache.bcel.internal.generic.PUTFIELD;

import es.upv.pros.tunnel.abstractClasses.AbstractDevice;
import es.upv.pros.tunnel.interfaces.IActuatorSwitch;
import es.upv.pros.tunnel.interfaces.ITunnelWriter;
import es.upv.pros.tunnel.interfaces.TunnelConstants;

public class CalimeroSwitch extends AbstractDevice implements IActuatorSwitch {
	public ITunnelWriter myTunnel;
	

	public CalimeroSwitch(BundleContext context,String address, String description,String deviceType, String deviceSubType, String iD, String location, String manufacturer, String model, String name, String profile, String serialNumber, String tunnel, String dataType, Hashtable<String, Object> otherProperties){
		super(address, description, deviceType, deviceSubType, iD, location, manufacturer, model, name, profile, serialNumber, tunnel, dataType, otherProperties);
		try {
			ServiceReference[] sr=context.getServiceReferences(ITunnelWriter.class.getName(), "("+TunnelConstants.TUNNEL_NAME+"="+this.getTunnel()+")");
			if(sr!=null&&sr.length>0){
				myTunnel=(ITunnelWriter) context.getService(sr[0]);
			}
		} catch (InvalidSyntaxException e) {
			e.printStackTrace();
		}
		
	}

	public CalimeroSwitch(BundleContext context, Hashtable<String, String> props, Hashtable<String,Object>otherProperties){
		super(props,otherProperties);
		try {
			ServiceReference[] sr=context.getServiceReferences(ITunnelWriter.class.getName(), "("+TunnelConstants.TUNNEL_NAME+"="+this.getTunnel()+")");
			if(sr!=null&&sr.length>0){
				myTunnel=(ITunnelWriter) context.getService(sr[0]);
			}
		} catch (InvalidSyntaxException e) {
			e.printStackTrace();
		}
		fillStates();
	}

	public void fillStates(){
		Hashtable<Boolean, String> substates=new Hashtable<Boolean, String>();
		substates.put(true, "ON");
		substates.put(false, "OFF");
		this.states.put("ON_OFF",substates);

		substates=new Hashtable<Boolean, String>();
		substates.put(true, "ALARM");
		substates.put(false, "NO_ALARM");
		this.states.put("ALARM",substates);

		substates=new Hashtable<Boolean, String>();
		substates.put(true, "ENABLED");
		substates.put(false, "DISABLED");
		this.states.put("ENABLED_DISABLED",substates);
	}

	public void switchOff() {
		myTunnel.writeBoolean(this.getAddress(), false);
		myTunnel.putActuatorValueOnDataCache(this.getAddress(), false);

	}

	public void switchOn() {
		myTunnel.writeBoolean(this.getAddress(), true);
		myTunnel.putActuatorValueOnDataCache(this.getAddress(), true);

	}

	public String getState() {
		Hashtable<Boolean,String> myStates=states.get(this.getSubType());
		Boolean actSta=(Boolean)myTunnel.getActuatorState(this.getAddress());
		String myState=myStates.get(actSta);
		return myState;

	}


}
