package es.upv.pros.tunnel.calimero.impl;

import java.util.Hashtable;

import org.osgi.framework.BundleContext;
import org.osgi.framework.InvalidSyntaxException;
import org.osgi.framework.ServiceReference;

import es.upv.pros.tunnel.abstractClasses.AbstractDevice;
import es.upv.pros.tunnel.interfaces.IDevice;
import es.upv.pros.tunnel.interfaces.ITunnelWriter;
import es.upv.pros.tunnel.interfaces.IActuatorVerticalMovement;
import es.upv.pros.tunnel.interfaces.TunnelConstants;

public class CalimeroVM extends AbstractDevice implements IActuatorVerticalMovement {

	ITunnelWriter myTunnel;
	
	public CalimeroVM(BundleContext context,String address, String description,String deviceType, String deviceSubType, String iD, String location, String manufacturer, String model, String name, String profile, String serialNumber, String tunnel, String dataType, Hashtable<String, Object> otherProperties){
		super(address, description, deviceType, deviceSubType, iD, location, manufacturer, model, name, profile, serialNumber, tunnel, dataType, otherProperties);
		try {
			ServiceReference[] sr=context.getServiceReferences(ITunnelWriter.class.getName(), "("+TunnelConstants.TUNNEL_NAME+"="+this.getTunnel()+")");
			if(sr!=null&&sr.length>0){
				myTunnel=(ITunnelWriter) context.getService(sr[0]);
			}
		} catch (InvalidSyntaxException e) {
			e.printStackTrace();
		}
		
	}
	
	public CalimeroVM(BundleContext context, Hashtable<String, String> props, Hashtable<String,Object>otherProperties){
		super(props,otherProperties);
		try {
			ServiceReference[] sr=context.getServiceReferences(ITunnelWriter.class.getName(), "("+TunnelConstants.TUNNEL_NAME+"="+this.getTunnel()+")");
			if(sr!=null&&sr.length>0){
				myTunnel=(ITunnelWriter) context.getService(sr[0]);
			}
		} catch (InvalidSyntaxException e) {
			e.printStackTrace();
		}
	}
	
	public void moveDown() {
		myTunnel.writeBoolean(this.getAddress(), false);
		myTunnel.putActuatorValueOnDataCache(this.getAddress(), false);
		
	}

	public void moveUp() {
	myTunnel.writeBoolean(this.getAddress(), true);
	myTunnel.putActuatorValueOnDataCache(this.getAddress(), true);
		
	}

	public void stop() throws Exception {
		try {
			if(this.getOtherProperties().containsKey(IVMDEVICE_SECOND_ADDRESS)){
				myTunnel.writeBoolean((String) this.getOtherProperties().get(IVMDEVICE_SECOND_ADDRESS), false);
			}
			else{
				throw new Exception("SECOND ADDRESS NOT SPECIFIED");
			}
		} catch (Exception e) {
			throw e;
		}
		
	}

	public Object getState() {
		return myTunnel.getActuatorState(this.getAddress());
	}

	@Override
	public void fillStates() {
	}

}
